// You can import API functions like this from D3.js.
import { select } from 'd3';

const svg = select('svg');

// You can import local ES6 modules like this. See message.js!
import { message } from './myMessage';

// This line uses D3 to set the text of the message div.
select('#message').text(message);

const margin = {top: 20, right: 20, bottom: 90, left: 120},
width = 5000 - margin.left - margin.right,
height = 1200 - margin.top - margin.bottom;

//const width = +window.innerWidth;
//const height = +window.innerHeight;

svg.attr('width', width + margin.left + margin.right);
svg.attr("height", height + margin.top + margin.bottom);

/*const circleGroup = svg
  .append('g')
  .attr(
    'transform',
    `translate(${width / 2}, ${height / 2})`
  );

circleGroup
  .append('circle')
  .attr('cx', -150)
  .attr('fill', 'green')
  .attr('r', 50);
circleGroup
  .append('circle')
  .attr('fill', 'blue')
  .attr('r', 50);
const circle3 = circleGroup
  .append('circle')
  .attr('fill', 'red')
  .attr('cx', 150)
  .attr('r', 50)
  .on('mouseover', function () {
  	circle3.attr('fill', 'black');
  })
	.on('mouseout', function(){
		d3.select(this).attr('fill', 'red')
	})
;

var button = d3.select("button")
			.on("click", function() {
       		d3.selectAll("circle").transition().duration(2000)
        				.attr("cx", 0)
      })
*/

var tooltip = d3.select("body").append("div")	
    .attr("class", "tooltip")				
    .style("opacity", 0)
		.style("background", "white")

const group = svg.append("g")
									.attr("transform", "translate(" + margin.left + "," + margin.top + ")");
/*
// Parse the Data
d3.csv("https://raw.githubusercontent.com/holtzy/data_to_viz/master/Example_dataset/7_OneCatOneNum_header.csv").then(data => {

// X axis
var x = d3.scaleBand()
  .range([ 0, width ])
	.domain(data.map(function(d) { return d.Country; }))
  .padding(0.2);
//x.domain(d3.extent(data, d => d["Country"]))
group.append("g")
  .attr("transform", "translate(0," + height + ")")
  .call(d3.axisBottom(x))
  .style("fill", "red")
  .selectAll("text")
    .attr("transform", "translate(-10,0)rotate(-45)")
    .style("text-anchor", "end");

// Add Y axis
var y = d3.scaleLinear()
  .domain([0, 13000])
  .range([ height, 0]);
group.append("g")
  .call(d3.axisLeft(y));

// Bars
group.selectAll("rect")
  .data(data)
  .enter()
  .append("rect")
    .attr("x", function(d) { return x(d.Country); })
    .attr("y", function(d) { return y(d.Value); })
    .attr("width", x.bandwidth())
    .attr("height", function(d) { return height - y(d.Value); })
    .attr("fill", "#69b3a2")

})


throw new Error()*/

function draw(data) {
  var yScale = d3.scaleLinear()
                .domain([0, d3.max(data, d => +d["2022 Population"])])
                .range([height, 0])
    //yScale.domain(d3.extent(data, d => d["2022 Population"]))
		// console.log(yScale(10))
  /*var xScale = d3.scaleLinear()
								.domain(["Jan", "Fev", "Mar"])
	var xAxis = d3.axisBottom(xScale)
								.scale(xScale)*/
  var xScale = d3.scaleBand()
    .range([0, width])
  	.domain(data.map(function(d) { return d.Country; }))
  	.padding(0.2)
  	// xScale.domain(d3.extent(data, d => d["Country"]))
  
  var xAxis = d3.axisBottom(xScale)
            /*.ticks(4)
            .tickFormat(d3.timeFormat("%b"))*/
  var yAxis = d3.axisLeft(yScale)

  //.ticks(4);
  
  group.append("g")
      .attr('transform', "translate(0, 0)")
      .classed('y-axis', true)
      .call(yAxis)
  
  group.append("g")
      .attr('transform', "translate(0," + height + ")")
      .classed('x-axis', true)
      .call(xAxis)
      .selectAll("text")
      .attr("transform", "translate(-10,0)rotate(-60)")
      .style("text-anchor", "end");
  
  /*group.append("g")
				.call(xAxis)*/
  
  /*group.append("g")
.attr('transform', "translate(0," + "150" + ")")
.classed('x-axis', true)
.call(xAxis)*/
  
  	group.selectAll('rect')
        .data(data)
        .enter()
        .append('rect')
        .attr('width', xScale.bandwidth())
        .attr('height', function(d) { return height - yScale(d["2022 Population"]); })
  			.attr('x', d => xScale(d["Country"]))
  			.attr('y', d => yScale(d["2022 Population"]))
  			.attr("population", d => d["2022 Population"])
  			.on("mouseover", d => {
      			tooltip.transition()		
                .duration(200)		
                .style("opacity", .9);		
            tooltip.html(d.Country + "<br/>"  + d["2022 Population"])	
                .style("display", "block")
              	.style("position", "absolute")
              	.style("left", (d3.event.pageX) + "px")		
                .style("top", (d3.event.pageY - 28) + "px");	
    		})
  			.on("mouseleave", d => {
      		tooltip.style("display", "none")
    		})
}

var data = [];
/*d3.csv("world_population.csv", function(r) {
  // console.log(data.Country +": "+ data["2022 Population"])
	data[ data.length ] = r;
  
  /*group.append("rect")
  				.attr("x", data.length*5)
  				.attr("y", 25)
  				.attr("width", 5)
  				.attr("height", 10)* /
  })*/
d3.csv("world_population.csv")
  .then(loadedData => {
  
  		data = loadedData;
          
			draw(data)
  	
	})

const button = select("body").append("button").text("sortAsc")
				.on("click", e => {
          
          group.html("");
          
          data.sort(function(a, b) {
            return d3.ascending(+a["2022 Population"], +b["2022 Population"])
          })
          
          draw(data)
        })